pro aide, SUJET = sujet, message

; Aide en ligne des logiciels NRH1


message = ["No subject selected for HELP !!! ",$
	 " Format: aide, SUJET = subject, message" ]

IF NOT KEYWORD_SET(SUJET) THEN RETURN

; -----------------------------------------------------------------------------
IF sujet EQ "filenames" THEN BEGIN
	message = [ $ 
	" ", $
	"NRH1 handles 1D images from the NRH and parameters derived from", $
	"these. When the appropriate computations are carried out, NRH1 ", $
	"generates new files with standard file names, based on the name of", $
	"the 1D image file.", $
	" ", $
	"The 1D image files are named ", $
	"                      name.ext,", $
	"where ext is 'ewN' or 'nsN', depending on the NRH array. N is a ", $
	"number that designates the observing frequency, in general  ", $
	"N=1, 2, ... in the order of increasing frequency. ", $
	" ", $
	"Image files from which a reference scan  has been subtracted ", $
	"(option DIFFERENCE) have the standard name ", $
	"                  bck_name.ext.", $
	" ", $
	" 1D position files contain the channel of the centroid, the width, ", $
	"amplitude and flux density of localized sources in the 1D images. ", $
	"Their standard names are", $
	"                  'pI' + name.ext  (Stokes parameter I) ", $
	"                  'pV' + name.ext  ( Stokes parameter V). ", $
	" ", $
	" 2D position files are constructed from 1D position files. They ", $
	"contain the heliographic co-ordinates in solar radii and the ", $
	"flux densities measured with the EW and NS arrays of the NRH. ", $
	"They have the same name as the 1D postion files. Their extension ", $
	"is              '2dN'  (N as above). ", $
	" ", $
	"Flux files contain the flux density, both I and V, the centre", $
	"and the width of the channel interval over which the flux density", $
	"is evaluated. Their name is  ", $
	"                  'f' + name.ext .", $
	" ", $
	"Note that when you compute a new position from the same file of ", $
	" 1D images, the result will be written in the existing position", $
	"file. The same is true for the 2D position files and the flux files.", $
	" ", $
	"The standard file names may be changed by the user. " $
	
	]  
ENDIF

; -----------------------------------------------------------------------------
IF sujet EQ "traces" THEN BEGIN
	message = [ $ 
	" ", $
	"The following options are available:", $
	" ", $
	"CONTOURS: Contours or colour levels of constant 1D-brightness ", $
	"          (Stokes param. I or V) as a function of time. ", $
	"          Further options: Identification of local sources, ", $
	"                           computation of their parameters. ", $
	"                           Plot of centroid position upon contours.", $
	" ", $
	"SCAN:   Spatial scan of 1D-brightness (Stokes param. I and/or V)", $
	"          Options: plot of a single scan (opt. 'SCAN'), ", $
	"                   single scan + identification of local ", $
	"                   sources (opt. 'SCAN+DECOMP'), ", $
	"                   series of scans (opt. 'SERIES')", $
	"                   'movie' of scans (opt. 'ANIMATION')", $
	" ", $
	"F(TIME): Time history of a parameter. The parameter is contained",$
	"          in a 1D 'position' file, a 1D 'flux' file, or a 2D 'position'",$
	"          file (examples: channel, amplitude, flux, heliogr. EW-coord.)", $ 
	" ", $
	"MAP: Map of heliographic positions, read from a file or entered by", $
	"        the user. " $
	]  
ENDIF

IF sujet EQ "calculs" THEN BEGIN
	message = [ $ 
	" ", $
	" 2D POS: Heliographic positions. Input: 1D positions (EW & NS).", $
	" ", $
	" 1D FLUX: Flux density of 1D images (I & V). Input: 1D images.", $
	" ", $
	" DIFFERENCE: Computation and subtraction of an average scan from ", $
	"             1D images. ", $
	" SHIFT FOV: Fold part of a 1D image from the western to the eastern",$
	"        or from the northern to the southern border, in order to", $
	"        enable tracking of a source which quits the field of view."$  
	]  
ENDIF

; -----------------------------------------------------------------------------

IF sujet EQ "listings" THEN BEGIN
	message = [ $ 
	" ", $
	"CHECK HEADER: Listing of the header of an NRH1 file.", $
	" ", $
	"F(TIME): Listing of a file describing the time history of a ", $
	"          series of parameters (1D 'position' file, 1D 'flux' ", $
	"          file, 2D 'position file). Output on screen or in an ", $
	"          IDL SAVE/RESTORE file. " $
	]  
ENDIF

; -----------------------------------------------------------------------------

IF sujet EQ "plot_options" THEN BEGIN
	message = [ $ 
	"            *** Information on plot options: ***         ", $
	" ", $
	"Plot to X/ to PS: Select output. 'PS' creates a postscript file", $
	"                  result.ps. This file is overwritten each time", $ 
	"                  you select 'Plot to PS'. You can save it by ", $
	"                  changing the name ('UNIX or VMS command'). ", $
	"                  Switch back to 'Plot to X'in order to close ", $
	"                  the postscript file.", $
	" ", $
	"BLACK & WHITE/COLOUR: Required for PS colour output only. ", $
	" ", $
	"PORTAIT/LANDSCAPE : Format of the POSTSCRIPT output. ", $
	" ", $
	"PRINT PS FILE ... : Print file result.ps on the selected printer. ", $
	" ", $
	"VIEW PS FILE ... : Display result.ps on screen (GHOSTVIEW). Note", $
	"                   that colour output may be plotted black & white", $
	"                   on screen if GHOSTVIEW is called while IDL is ", $
	"                   operating. In this case you must quit your IDL", $
	"                   session if you want to make sure that the PS ", $
	"                   file is coloured.", $
	" ", $
	"Nb. of plots (x, y): Number of plots in the horizontal (x) and ", $
	"                     vertical (y) direction.", $
	" ", $
	"Window width/height: Width and height of the X-window in pixels.", $
	"                     For PS output, the plot fits within an A4 page.", $
	" ", $
	"PROBLEMS KNOWN TO DATE:  The juxtaposition of several plots on one ", $
	"                        page is not sure to give satisfying results."$

	]  
ENDIF

; -----------------------------------------------------------------------------

IF sujet EQ "choix_isoph" THEN BEGIN
	message = [ $ 
	"                  *** Choice of contour levels: ***",  $
	" ", $
	"Highest contour = x*Imax (Imax=peak level in the plotted field, ", $ 
	"x = value of the '% of	 peak level'-slider). ", $
	" ", $
	"The step dI between contours may be chosen in one of the following", $
	"ways:", $
	" ", $
	" 1) linear scale, contours 0.5*dI, 1.5*dI, ... , x*Imax ; ", $
	"    (x*Imax = (N-0.5)*dI, N='number of contours'); ", $
	" ", $
	" 2) linear scale, x*Imin, x*Imin+dI, ... , x*Imax (Imin=smallest ", $
	"    peak value in the 1D images contained in the plotted field); ", $
	"    this option is suited for fields with a large dynamic range; ", $
	" ", $
	" 3) logarithmic scale between the same minimum and maximum values", $
	"   as 2).", $
	" ", $
	"For V contours the highest contour is  x * peak of the ", $
	"absolute values of the amplitudes; the lowest contour is ", $
	"the negative value of the highest one. Therefore the number of ", $
	"contours actually plotted may be smaller than the chosen value N. " $
	]
ENDIF

; -----------------------------------------------------------------------------

IF sujet EQ "recherche" THEN BEGIN
	message = [ $ 
	"      *** Extraction of elementary sources from 1D images: ***",  $
	" ", $
	"An elementary source is identified by comparing the raw image with", $
	"the running mean over N channels (N='Mean [chan]'). A Gaussian or", $
	"its sum with a constant, straight line, or parabola, is fit to the", $
	"data within the two local minima around the  point of the", $
	"image with highest excess above the running mean. The Gaussian ", $
	"part of the fitted function is subtracted from the image. This ", $
	"procedure is repeated  as long as the number of iterations does ", $
	"not exceed the pre-selected value ('Iterations'), and while the ", $
	"excess of the brightest point is greater than W timesthe standard  ",$
	"deviation of the raw data with respect to the running mean ",$
	"(W='Weight'). You can see how this works in an individual 1D image", $
	"by using the 'DECOMP' option of the SCAN menu. ", $
	" ", $
	"Upon pushing 'Extract individual sources', you are requested to ", $
	"delimit a field in the contour/gray-scale plot encompassing the source ",$
	"you want to analyze. The central scan of the delimited field is taken. ", $
	"The source with highest excess is identified, and is searched for in  ", $
	"preceding and following images. The procedure continues as long as it",$
	"identifies a source whose distance to the one previously found is ", $
	"smaller than the pre-selected value ('Dist [chan]'). The data are ", $
	"written into a 'position' file, which may already exist or not. If", $
	"it exists, the procedure checks whether the source to be written ", $
	"is already there or not. " $
	]  
ENDIF

; -----------------------------------------------------------------------------

IF sujet EQ "par_image" THEN BEGIN	; Parametres d'une image (CARTE 2D)
	message = [ $ 
	"Underlay an image under the plot of heliographic positions. ", $
	"The co-alignment of the image with the positions is achieved ", $
	"by giving the centre and the radius of the solar disk in ", $
	"pixels, and the inclination (in degrees) of the vertical axis ", $
	"with respect to the solar north-south direction (the angle is ", $
	"positive when solar north is on the right of the vertical through", $
	"the centre of the disk).", $
	" ", $	
	"You may enter these values manually. In case data are read from a ", $
	"fits file, use 'FITS HDR' to print the fits header. ", $
	" ", $	
	"You can also compute them from an image: choose option ", $
	"'COMP. C, r'. The image will then be plotted on the screen, and ", $
	" the  IDL-procedure CIR_3PNT will be called which determines the ", $
	"centre and radius of a circle when three points are given on the  ", $
	"circumference (click on these points upon request in the MESSAGE", $
	"window of the widget). If necessary, determine the inclination ", $
	"in a similar way by clicking on 'COMP. incl.'." $
	]  

ENDIF

IF sujet EQ "pos_man" THEN BEGIN	; Positions 2D; entree manuelle
	message = [ $ 
	"Heliographic positions can be computed from the 1D centroid positions", $
	"(observed with the EW and SN branches of the NRH) expressed in ", $
	"channels. These positions are plotted by a symbol chosen as a  ", $
	"function of frequency or by the user (button Plot layout). If the ", $
	"widths of the 1D sources are >0 (units: channel), a cross is plotted. ", $
	" ", $
	"The calculation of heliographic positions does not correct for", $
	"refraction in the Earth's ionosphere (button No corr.), or", $
	"attempts a correction using a static model (button static corr.).", $
	"Correction using electron density measurements from the Poitiers ", $
	"station does not work for the time being. ", $
	" ", $
	"You can save the source parameters set in the fields to a file by", $
	"pushing the button WRITE. READ displays the data in this file as ", $
	"a list widget from which you can choose a data set (push Done when", $
	"ready). SET puts this data into the fields for manual entry. The", $
	"file (named manpos_nrh.dat) contains ASCII data and can hence be  ", $
	"edited.  " $
	]  
ENDIF

IF sujet EQ "pos2d" THEN BEGIN	; Calcul positions 2D
	message = [ $ 
	"Computation of heliographic positions from one-dimensional ",$
	"positions from the east-west and north-south branches of the NRH.",$
	" ",$
	"Choose the name of the file containing 1D EW - positions and",$
	"make sure that the corresponding file with north-south positions",$
	"exists. Push INIT before starting the computation, WRITE FILE",$
	"when all 2D positions have been computed (maximum number of 2D ",$
	"positions allowed: 9). ",$
	" ",$
	"The start and end time of the interval during which the helio- ",$
	"graphic positions are computed can be selected. The east-west and",$
	"north-south positions are associated as indicated by the numbers",$
	"('EW pos. # m', 'NS pos. # n'). ",$
	" ",$
	"Corrections for propagation in the terrestrial ionosphere can be",$
	"applied with a static model or using ionospheric density measure-",$
	"ments taken in Poitiers. THESE OPTIONS DO NOT YET WORK." ,$
	" ",$
	"After each computation the computed heliographic position is plotted." ,$
	"This plot is for control purposes only. It cannot be directed to" ,$
	"a PS-file." $
	]
ENDIF

IF sujet EQ "calcflux" THEN BEGIN	; Calcul flux 1D
	message = [ $ 
	"The flux density is the integral of the 1D brightness distribution.",$
	"It is computed within an interval of NRH channels that can be ", $
	"selected by the user (widget min:/max:). The default interval is ", $
	"the whole image.", $
	" ", $
	"The flux density can be evaluated over a fixed interval (option ", $
	"'Fixed interval') or by tracking the point of maximum brightness ", $
	"(option 'Track peak'; in this case 'Width [chan]' gives the width ", $
	"of the range, centered at the peak, over which the flux density is ",$
	"computed.", $
	" ", $
	"The output is written to a file.." $
	]  

ENDIF

RETURN
END
