
;+ ***********************************************************************
; NAME:
;	TRACE1D
;
; PURPOSE:
;	Cette procedure trace l'evolution temporelle d'un parametre
;
; CATEGORY:
;	NRH1 Trace
;
; CALLING SEQUENCE:
;	TRACE1D, Temps, Ordonnee 
;
; INPUTS:
;	TEMPS 		Tableau de temps [abscisse; ms du jour]
;	ORDONNEE	Tableau des grandeurs a tracer (ordonnee)
;	
; KEYWORD PARAMETERS:
;	TITLE		Titre (au-dessus du cadre)
;	XTITLE		Annotation de l'abscisse
;	YTITLE		Annotation de l'ordonnee		
;
; MODIFICATION HISTORY: bonmartin@obspm.fr
;	Adapte de XHELIO le 20/12/98
;-*******************************************************************

PRO trace1d, temps, ordonnee, TITLE = title, XTITLE=xtitle, YTITLE=ytitle

; Transformation du temps en hh:mm:ss
milsec_axis, temps, tickv, tickl, ticks

IF NOT KEYWORD_SET(TITLE) THEN title = " "
IF NOT KEYWORD_SET(XTITLE) THEN xtitle = "Universal Time"
IF NOT KEYWORD_SET(YTITLE) THEN ytitle = " "

plot,temps, ordonnee, $
		XSTYLE=1, YSTYLE=2,  $
;		ymargin=[9,2], xmargin=[8,5], $
		 PSYM=10,$
        	XTICKV = tickv, XTICKS = ticks(0), XMINOR = ticks(1), $
		XTICKNAME = tickl,$
		XTITLE=xtitle, YTITLE=ytitle, $
		TITLE=title

END
