
;+ ***********************************************************************
; NAME:
;	FOPEN_PNG
;
; PURPOSE:
;	Lecture des donnees sous forme d'image PNG
;
; CATEGORY:
;	Fichier
;
; CALLING SEQUENCE:
;	 FOPEN_PNG,File, Str_inf2d

;
; INPUTS:
;	File	chemin et nom du fichier a lire
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;	Str_inf2d	structure d'information de fichier (NRH_STR_INF2D)
;
; PROCEDURE:
;	Cette procedure lit l'image contenue dans un fichier FITS PNG,
;	l'affiche et demande de determiner le cercle optique, puis
;	remplit la structure STR_INF2D
;;			  Str_inf2d.Content est = 'PNG'
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (bonmartin@obspm.fr) le 09/09/98
;       24/03/2005 A Bouteille :  Si l'image au format png est en 24
;       bits avec 3 dimensions data(3,nx,ny), on suppose qu'on veut
;       du noir et blanc donc on prend data(0,*,*) le rouge qui doit etre peu
;       different de data(1,*,*)le vert et de (data(2,*,*) le bleu
;       06/11/2008 (AB) gestion des images 2D et 3D (true color)
;-*******************************************************************

PRO FOPEN_PNG, File, Str_inf2d

Str_inf2d.Instrume = 'PNG'
	READ_PNG,File, data, R, G ,B
;        if (size(data))(1) eq 3 then data = reform(data(0,*,*))
;help,data
	Optic_circ, DATA, Xcen, Ycen, Ray

	STR_Inf2d.Xcen=Xcen&Str_inf2d.Ycen=Ycen
	Str_inf2d.ray=ray
	Str_inf2d.CONTENT = 'PNG'
	str_inf2d.nim = 1
	Str_inf2d.hd = ''
	Str_inf2d.hf = Str_inf2d.hd
		SZ = SIZE( Data)
        if SZ[0] eq 2 then begin
print,' Image size : ', sz(1),sz(2)
            Str_inf2d.npx = Sz(1)
            Str_inf2d.npy = Sz(2)
        end else begin
print,' Image size : ', 3, sz(2),sz(3)
            Str_inf2d.npx = Sz(2)
            Str_inf2d.npy = Sz(3)
        endelse
	Str_inf2d.Tscan = 0.0
	Str_inf2d.Freq = 0.0
	Str_inf2d.date = ''

END
