
;+ ***********************************************************************
; NAME:
;	NRH_FCLOSE
;
; PURPOSE:
;	Fermeture d'un fichier NRH ouvert par NRH_FOPEN
;
; CATEGORY:
;	Fichiers
;
; CALLING SEQUENCE:
;	NRH_FCLOSE, Str_Inf2d
;
; INPUTS:
;	Str_inf2d	structure d'information de fichier
;

; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	Non
;
; COMMON BLOCKS:
;	Non
;
; PROCEDURE:
;	Cette procedure ferme l'unite et remet STR_INF2D.UNIT a 0
;	Si STR_INF2D = 0 elle est inoperante
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr) le 02/09/98
;-*******************************************************************


PRO NRH_FCLOSE, Str_inf2d

	If Str_inf2d.Unit NE 0 THEN BEGIN
		FXBCLOSE, Str_inf2d.Unit
		Str_inf2d.Unit = 0
	END

END
