
PRO ECH_RS, deb, fin, nbp, tab

;+ ***********************************************************************
; NAME:
;	ECH_RS
;
; PURPOSE:
;	Cette procedure genere une echelle en RAYONS SOLAIRES a partir
; des coordonnees de debut et de fin (en rayons solaires)
;
; CATEGORY:
;	RADIO, ECHELLES
;
; CALLING SEQUENCE:
;	ECH_RS, deb, fin, nbp, tab
;
; INPUTS:
;	DEB	coordonnee du premier point (rayons solaires)
;	FIN	coordonnee du dernier point (rayon solaire)
;	NBP	nombre de points
;
; OUTPUTS:
;	TAB	tableau de coordonnees en rayons solaires
;
; EXAMPLE:
;	I1, I2, les indices des points d'une image dont le centre est
; a l'indice C et le Rayon
;	P1 = IND_RS (I1, C, R)
;	P2 = IND_RS (I2, C, R)
;	ECH_RS, P1, P2, 100, AXE
; donne un tableau AXE de 100 valeurs contenant les coordonnees de 100 points
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin le 21/10/97 (bonmartin@obspm.fr)
;le 14/11/97	increment en pixels remplace par le rayon solaire
;-*******************************************************************

       tab = fltarr (nbp)

       dpi = (fin - deb) / (nbp -1)

       FOR i=0, nbp-1 DO $
             tab(i) = deb + (i * dpi)

end

