PRO RH_DP_AIDE, SUJET = sujet, message
;+ ***********************************************************************
; Aide en ligne du logiciel DPATCH
; 26 janvier 2010 : modif du contenu sujet = 'get_files' pour lien 
;  avec secchirh.obspm.fr
; remplace le nrh download de bass2000 par celui du site radio monitoring
;-
;***********************************************************************
if sujet eq 'get_files' then begin
    message = [ $
        " ", $
   "Before computing images you must download Nancay RH files from ", $ 
   "the http server 'Monitoring Radio': ", $
   "             http://secchirh.obspm.fr    ", $
   " Select : ", $
   "  DOWNLOAD DATA/NRH ", $
   "  This page gives you access to archive NRH data.", $ 
   " You can get integrated quicklook files (by direct download) ", $
   "  or high time resolution files (on demand only).", $
   "  These files are binary files in Nancay proprietary format ", $ 
   "  and NOT FITS files.", $
   "  They provide data at 5 frequencies ", $
   "  (usually 164.0MHz 236.6MHz 327.0MHz 410.5MHz 432.0MHz).", $ 
   " The program 'Visibility to Image' in the Solar Soft package", $
   "  computes images and creates one NRH fits file per frequency. ", $
      " ", $
   " "   ] 
endif
if sujet eq 'specifying the image' then begin
    message = [ $
   "         SPECIFYING THE IMAGE :", $
   " ", $
   " - Specifications for heliographic images :", $ 
   "     . Width of field of view (sol radii) ", $
   "       - 4 is the usual value, suitable in most cases.", $
   "       - 8 can be used for CMEs or high altitude type IV bursts.", $
   "     . ", $
   "     . P angle rotation : 0-No 1-Yes.", $
   "     . Number of periods of interferometric images used to derive the", $
   "         final image : it must be >1 (eg 1.5) if the width of the field", $
   "         of view is larger than 4 Rs." ,$
   "     . Number of pixels (np), in EW and NS (128 or 256) .", $ 
   "     . Interpolation mode for obtaining final image : linear (1), cubic", $
   "         spline (2) or fft (3). For most cases (1) is convenient and ", $
   "         much faster.", $
   " "   ] 
endif
if sujet eq 'selection of harmonics' then begin
    message = [ $
   "         SELECTION OF HARMONICS :", $
   "     . Use of extension antennas, providing better resolution but also", $
   "         a more complicated shape of the dirty beam. In a first time,", $
   "         keep all the extensions. Sometimes it can be necessary to ", $
   "         suppress E2 which is difficult to calibrate. In case of", $
   "         Clean, E0 is required to reduce the alias(1), especially.", $
   "         before jan 2004, when the AA were not yet installed.", $
   "     . Addition of the redundancy for some short baselines. ",$
   "         Usually not recommended because of biased (spoilt) outputs.", $
   "     . Suppression of baselines involving antennas affected by problems ",$
   "         (breakdown, terrestrial interferences etc.) ." ,$ 

   " - INTERPOLATION FOR OBTAINING ODD EW HARMONICS.", $
   "    Odd EW harmonics were not obtained in the uv plane outside the u ", $
   "    axis before jan 2004. Since this date they are obtained over a ", $
   "    small area around the origin. This results in the presence of ", $
   "    ""alias"" (spurious sources distant from the actual ones by ", $
   "    half of the EW width of the field of view). These alias are ", $
   "    somewhat smaller than the source but they can be misleading.", $
   "    Such alias can be removed if the visibility function can be ", $
   "    reliably interpolated to restore odd harmonics. This is the case ", $
   "    when only one intense (non thermal) compact solar source is ", $
   "    dominant. The visibility is then a relatively slowly varying ", $
   "    function if the source is close to the center of the field of view ", $
   "    (when it is far from the field center (FC), there is a fast phase", $ 
   "    rotation). ", $
   "    The visibility of the wide quiet sun (QS) is too variable to be ", $
   "    thus interpolated.", $
   "    Removing QS alias requires additional baselines.", $
   "    The procedure consists in :", $
   "   . shifting the maximum of the dirty image to the FC,", $
   "   . calcultating its Fourier Transform (FT) ", $
   "   . restoring odd harmonics through interpolation,", $
   "   . calculating the new image by inverse FT,", $
   "   . shifting back the compact source to its original position", $.
   "    The direct interpolation of the visibility would lead to suppress ", $
   "    the source itself and to reinforce its alias when the source is ", $
   "    far from th FC).", $ 
   "    The resulting image is much improved : it does not exhibit alias", $ 
   "    any more and has a flat base.", $
   "    The procedure is about 2000 times faster than CLEAN, which can thus", $
   "    be avoided in most cases. ", $
   "    For complex cases, the user can define the shift before inter-", $
   "    polation, as a compromise between several compact sources.", $ 
   " "]
endif
if sujet eq 'clean parameters' then begin
    message = [ $
 "INTRODUCTION ", $
 " ", $ 
 "The CLEAN procedure produces 'regular' images, not affected by side ", $ 
 "lobes and other artefacts, but consumes computational time (about 6 ", $ 
 "sec per image on XP1000 ALPHA). It can however produce artefacts ", $ 
 "such as spurious details. ", $
 " ", $
 "It includes several options defined by the following parameters. ", $
 " ", $
 " ", $
 "CLEAN PARAMETERS ", $
 "- CLEAN mode ", $
 "   . the residual is     added to the synthetic image (ordinary CLEAN) ", $
 "   . ------------ is NOT ---------------------------- ", $
 "- stopping iteration ", $
 "   . criteria : there are 4 different criteria : ", $
 "       1) residual becomes less than a given threshold ", $
 "       2) residual flux becomes less than a given threshold ", $
 "       3) residual begins to increase", $
 "       4) clean components change sign", $
 "       Criteria (1)(2)(3) can always be used. ", $ 
 "       Criteria (4) should be used only for Stokes I images in con- ", $
 "       junction with the option of not adding the residual, in case  ", $
 "       of bad calibration: CLEAN cannot then reproduce big negative  ", $
 "       side lobes which are thus ignored. The final image is simple ", $ 
 "       but small structures are also ignored. ", $
 "   . threshold (for criterion 1) : the user can choose a mutiplica- ", $
 "       tive factor of the internally defined threshold. This factor  ", $
 "       is usually unity (which corresponds to iteration numbers of a  ", $
 "       few hundreds, convenient for most cases), but it can be choo- ", $
 "       sen in the range (0.1 - 1) for describing faint structures in  ", $
 "       the image such as CMEs. Reducing the threshold correlatively  ", $
 "       increases the iteration and the computing time. The quality  ", $
 "       of the result is not improved for iterations larger than ", $
 "       ~ 2,000. ", $
 "- smoothing the cleaned image : the user chooses the half power half  ", $
 "    width in the uv plane (spatial harmonics from 0 to 64). Usual  ", $
 "    (20, 30). In case of enhanced iteration (eg reduction of thres- ", $
 "    hold for CMES) it should be reduced to (11, 18) in order to avoid  ", $
 "    CLEAN spurious details (""water drops"") in the image. ", $
 " ", $
   " "]
endif
  return
  end  
