FUNCTION RH_HDR_TIME, date, ihms
;+ ***********************************************************************
; NAME:
;	RH_HDR_TIME
; PURPOSE:
;	Cette fonction effectue le codage date [et heure si le parametre ihms
;	est present] pour les mots-cles 
;	DATE_OBS, DATE_END , DATE et DATE-OBS du header FITS
;	format standard : CCYY-MM-DDThh:mm:ss[.sss...]Z
; CATEGORY:
;	Traitement de fichiers NRH	
; CALLING SEQUENCE:
;	chtime = HDR_TIME(idat,ihms)
; INPUTS:
;	date : jour,mois,an
; OPTIONAL INPUTS:
;	ihms : heure en millisec
; OUTPUTS:
;	Chtime : heure au format standard FITS
; MODIFICATION HISTORY:
;	Ecrit par: A. Bouteille
;	modif mai 98 : appel a la routine rh_date100 pour avoir une date 
;	      avec siecle quelque soit la date rentree sous forme j,m,a
;-*******************************************************************
  date(2)=rh_date100(date(2),/full)
  chdat = STRING(format="(i4.4,'-',i2.2,'-',i2.2)",$
  date(2),date(1),date(0) )
  if n_elements(ihms) eq 1 then begin
      chtime = msh(ihms, delim= '.')
      return,chdat+'T'+chtime+'Z'
  end else begin
      return,chdat
  endelse
  end
