FUNCTION RH_LINEAR_LU,  mat, vec, i_stop,    $	; entree
		        resul			; sortie

; Creation 5 juin 01
; But : resolution des systemes lineaires par la methode LU (cf numerical reci-
;	  pes).

; Rappel : la production de gaps dans les donnees pour tester CRAMER, 
;	     RH_LINEAR_LU et RH_LINEAR_SVD est en option dans FIT_TF_1D (dans 
;	     AUTOCAL_SUB.PRO)  pour i_test_gap=1.

; Notations :
;  mat		matrice du systeme lineaire en entree, non modifiee en sortie.
;  mat_2	identique a mat en entree, modofiee en sortie.
;  resul	vecteur des resultats (en sortie).
;  i_stop	1 pour arret controle

    mat_2 = mat		; pour eviter d'ecraser mat en sortie.
    LUDC, mat_2, index
	; mat_2	matrice n par n en entree, remplacee en sortie par une decom-
	;	  position LU d'une permutation de ses lignes.
	;  index vecteur de sortie contenant la permutation des lignes resul-
	;	  tant du pivotement partiel.

    resultat = LUSOL (mat_2, index, vec)

    return, resultat
    end				; fin de RH_LINEAR_LU. 
