;+ --------------------------------------------------------------------
;                     Selection d'un fichier
; --------------------------------------------------------------------
; rh_sel_fich, fpath, , filter, fich, typ1, typ2
; 	fpath : 	directory par defaut
;	separator : 	separateur
;	filter:		filtre
;	fich		nom du fichier
;			='' si pas de fichier selectionne
;	typ1		ier caractere du nom du fichier
;	typ2		2eme caractere du nom du fichier
;- ____________________________________________________________________

pro rh_sel_fich, fpath, filter, fich, typ1, typ2, $
                 MULTIPLE=MULTIPLE, MUST_EXIST=must_exist

  flag = 1
  IF KEYWORD_SET(MUST_EXIST) THEN flag = must_exist 
  IF fich EQ '' THEN BEGIN
     s = findfile(fpath+rh_separator()+filter, COUNT = count)
      IF count NE 0 THEN fich = s(count-1)
  ENDIF

  IF KEYWORD_SET(MULTIPLE) THEN BEGIN
     fich = DIALOG_PICKFILE(FILTER= filter, PATH = fpath, $
            TITLE = 'Selectionner un fichier', MUST_EXIST=flag, $
            GET_PATH = path1, /MULTIPLE_FILE, group = gp)
  ENDIF ELSE BEGIN
     fich = DIALOG_PICKFILE(FILTER= filter, PATH = fpath, $
            TITLE = 'Selectionner un fichier', MUST_EXIST=flag, $
            GET_PATH = path1, FILE = fich, group = gp)
  ENDELSE

;Type du fichier
  rh_fich_ctr, fich(0), fpath, typ1, typ2

  RETURN
END
