; --------------------------------------------------------------------
;          Selection (au moins 1)
;          Selection (0 1 ou n boutons ) quelconque
; modif mars 2002 : selection quelconque
; --------------------------------------------------------------------


function transform_csv,csv_result

  ; CSV fields
  ; 1 startdate, 2 enddate, 3 frequency, 4 polarMode, 5 antenna, 6 1 : working, 0 : out of order

endate  = csv_result.field2
freq    = csv_result.field3
mode    = csv_result.field4
antenna = csv_result.field5
working = csv_result.field6


missing_ewP_endate = endate[where((mode eq 'NP') and (stregex(antenna,'ew[0-9][0-9]') ge 0) )]
missing_ewP_freq =    freq[where((mode eq 'NP') and (stregex(antenna,'ew[0-9][0-9]') ge 0) )]
missing_ewP_mode =    mode[where((mode eq 'NP') and (stregex(antenna,'ew[0-9][0-9]') ge 0) )]
missing_ewP_work = working[where((mode eq 'NP') and (stregex(antenna,'ew[0-9][0-9]') ge 0) )]
missing_ewP_ante = antenna[where((mode eq 'NP') and (stregex(antenna,'ew[0-9][0-9]') ge 0) )]

missing_ewP_mode[*] = 'P'

new_csv = { $
    endate  : [endate ,missing_ewP_endate],$
    freq    : [freq   ,missing_ewP_freq], $
    mode    : [mode   ,missing_ewP_mode], $
    working : [working,missing_ewP_work], $
    antenna : [antenna,missing_ewP_ante] $
}

return,new_csv

end

function reorder_antennas_sel, sel,ant_names

    new_sel_order = indgen(n_elements(sel))
    ant_right_order = rh_antenne(n_elements(tab_sel_2d))
    for i=0,n_elements(ant_right_order)-1 do begin
      index = where(ant_names eq ant_right_order[i])
      if index ge 0 then new_sel_order[i] = sel[index]
    endfor
   return, new_sel_order

end


PRO rh_selection_Event, Event

common rh_wselection, t_sel, sel_01n, exclusive

  WIDGET_CONTROL, Event.Id, GET_UVALUE = Ev
  WIDGET_CONTROL, Event.top, GET_UVALUE = file_date
  WIDGET_CONTROL, widget_info(Event.top,FIND_BY_UNAME='widget_b'), GET_UVALUE=choices
  CASE Ev OF 

    'self': BEGIN
            if exclusive eq 0 then BEGIN
                t_sel(event.value)=event.select
  end else begin
      t_sel(*) = 0b
      tsel = event.value
      t_sel(tsel)=1b
  endelse
                
            END

    'fin':  BEGIN
            ind = WHERE(t_sel,nb)
            IF sel_01n eq 0 and nb EQ 0 THEN return
            WIDGET_CONTROL,EVENT.TOP,/DESTROY
            RETURN
            END
            
       'open_csv':  BEGIN
        csv_file = dialog_pickfile(path = "/Users/romagnan/data/nrh/csv/",FILTER='*.csv')
        csv_data = READ_CSV(csv_file)
                
        ; 48 antennas NP 32 antennas P
        ; copy  ew01->16 as p antennas
        antennas_struct = transform_csv(csv_data)
        ;params = csv_data
         WIDGET_CONTROL, Event.top, SET_UVALUE = antennas_struct
         
         date_jd = julday(strmid(file_date,2,2),strmid(file_date,4,2),strmid(file_date,0,2))
         date2_jd = julday(strmid(antennas_struct.ENDATE[0],2,2),strmid(antennas_struct.ENDATE[0],5,2),strmid(antennas_struct.ENDATE[0],8,2))
        
        if (date_jd ne date2_jd) then begin
          mess = ['Its seems that the Visibility file and the CSV are not related to the same date.',$
            'Visibility file : '+string(date_jd),$
            'CSV file : '+string(date2_jd)]
          
          res = dialog_message(mess,/information)
        endif
               
sel =  antennas_struct.working[$
   where((antennas_struct.mode eq (choices.polar_np)) and (antennas_struct.freq eq choices.chosen_freq))]

ant_names = antennas_struct.antenna[$
   where((antennas_struct.mode eq (choices.polar_np)) and (antennas_struct.freq eq choices.chosen_freq))]

new_sel = reorder_antennas_sel(sel,ant_names)

         widget_control,widget_info(event.top,find_by_uname='b_freq'),SET_VALUE = new_sel
  
  
         END
         

    ELSE:      
  ENDCASE

  RETURN
END
   

;; Widget pour selectionner des trucs avec des cases
;; à cocher. Les trucs en questions sont spécifiés en paramètres.
;; Titre : GUI title, nom_f : array of names of options, 
;; tab_sel_2d : array of 0/1 saying of option is selected or not (common bloc)

PRO rh_selection, titre, nom_f, tab_sel_2d, monofrequence = monofrequence, $
                  SEL_qcq = sel_qcq, $
                  GROUP = group
; pour la selection d'une seule frequence exclusive =1
;  la valeur t_sel renvoyee par cw_bgroup est un entier
;  sinon exclusive = 0 et t_sel est un tableau
common rh_wselection, tab_sel, sel_01n, exclusive

COMMON rh_rr_new_var, freq_selected, mode_selected

COMMON rh_wdpatch, nom, T_DEB,T_FIN, sel_freq, ipolar, iba, $
  out_dir, path_sel, fcmd, i_integ, t_integ

  tab_sel = tab_sel_2d
  if n_elements(monofrequence) eq 0 then exclusive = 0 else $
                                         exclusive = monofrequence

polar_np = ['NP','P']

  choices = { $
    chosen_freq:freq_selected, $
    polar_np:polar_np[mode_selected] $
  }
  
  
  print,choices.chosen_freq
  
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0
  t_sel = tab_sel
  if exclusive eq 1 then t_sel = 0
  sel_01n = 0
  IF N_ELEMENTS(sel_qcq) NE 0 THEN sel_01n=1  
  
  file_date = strmid(file_basename(nom),2,6)
  
  selb = WIDGET_BASE(GROUP_LEADER = GROUP, COLUMN = 1, $
         TITLE = titre,/modal,uvalue=file_date)

  b = WIDGET_BASE(selb, COLUMN=1, /FRAME,/BASE_ALIGN_CENTER,$
      /ALIGN_CENTER,uvalue=choices, uname='widget_b') 
  
  harmo_gui = 0 
      
  if exclusive eq 0 then begin
  ;  selection non exclusive 
       if N_ELEMENTS(t_sel) lt 10 then begin
          b_freq = CW_BGROUP( b, nom_f, COLUMN=1, /NONEXCLUSIVE, $
                   uvalue = 'self', SET_VALUE = t_sel,uname='b_freq')
      end else begin
        stokes_mode = ['Stokes I','Stokes I+V']
        mess = ['Disable antennas for '+choices.chosen_freq+'MHz and mode '+stokes_mode[choices.polar_np],nom]
        
        wtitle = widget_text(b, value=mess, ysize=2)
          b_freq = CW_BGROUP( b, nom_f, /NONEXCLUSIVE, $
                   uvalue = 'self', SET_VALUE = t_sel, ROW = 6,uname='b_freq')
            harmo_gui = 1        
      endelse
  end else begin 
  ;  selection exclusive 
              b_freq = CW_BGROUP( b, nom_f, COLUMN=1, /EXCLUSIVE, $
                uvalue = 'self', SET_VALUE = t_sel,uname='b_freq')
  endelse 
   
;Arret 
  b = WIDGET_BASE(selb, /ROW, /ALIGN_CENTER)
  b1 = WIDGET_BUTTON( b, VALUE = ' OK ', UVALUE = 'fin', $
       xsize=70, ysize=35, /FRAME)

  if (harmo_gui) then begin
    b2 = WIDGET_BUTTON( b, VALUE = ' OPEN CSV File ', UVALUE = 'open_csv', $
      xsize=70, ysize=35, /FRAME)

  endif
  


  WIDGET_CONTROL, selb, /REALIZE
  XMANAGER, 'rh_selection', selb, GROUP=group
  tab_sel_2d = tab_sel
  return
END

