
;+ ***********************************************************************
; NAME:
;	COMP_CIRCLE
;
; PURPOSE:
;	This procedure compute the polar parameters to plot a circle
;
; CATEGORY:
;	NRH General
;
; CALLING SEQUENCE:
;	COMP_CIRCLE, radius, angle, rayon 
;
; INPUTS:
;	Parm1:	Describe the positional input parameters here. Note again
;		that positional parameters are shown with Initial Caps.
;
; OPTIONAL INPUTS:
;	RADIUS	circle radius, =1. if parameter = 0
;	
; KEYWORD PARAMETERS:
;	RESOL	Number of the angle points computation, = 101 if
;		no present 
;
; OUTPUTS:
;	ANGLE	Array of angle values (Size= Resol)
;	RAYON	Circle radius (size=Resol)
;
; COMMON BLOCKS:
;	Non
;
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	Ecrit par:Ludwig Klein, J Bonmartin le 11/12/98
;-*******************************************************************

PRO COMP_CIRCLE, radius, angle, rayon, RESOL = resol

IPTS = 101
IF KEYWORD_SET(RESOL) THEN Ipts = Resol
IF n_elements(radius) eq 0 THEN radius=1.
;
rayon=fltarr(ipts)
delta=2.*!PI/(ipts-1)

angle = FINDGEN(ipts)*delta
rayon(*) = radius

end
