
;+ ***********************************************************************
; NAME:
;	OPLOT_CIRCLE
;
; PURPOSE:
;	Trace d'un cercle sur une image aux coordonnees 0,0
;
; CATEGORY:
;	TRACE
;
; CALLING SEQUENCE:
;	oplot_circle, radius
;
; INPUTS:
;	RADIUS	Rayon du cercle
;
; EXAMPLE:
;	OPLOT_CIRCLE, 1.
; trace un cercle representant le soleil optique sur une image representee
; en coordonnees heliographiques
;	Cette routine est equivalente a TVCIRCLE de IDLASTRO, mais ne deborde
; pas du cadre pour les traces de contours
;	Elle ne peut etre utilisee a la suite de TV ou TVSCL, car le cercle est
; centre sur les coordonnees O,O, utiliser alors TVCIRCLE  
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr)
;-*******************************************************************

pro oplot_circle, radius
IF n_elements(radius) eq 0 THEN radius=1.
;
ipts=101
rayon=fltarr(ipts)
delta=2.*!PI/(ipts-1)

angle = FINDGEN(ipts)*delta
rayon(*) = radius

		oplot, rayon, angle,/polar
		oplot,[0,0], [-1.,-1.1]
		oplot,[-1,-1.1], [0,0]
		oplot, [0.,0.], [1,1.1]
		oplot, [1,1.1], [0.,0.]
end
