
;+ ***********************************************************************
; NAME:
;	NRH_COLOR_PLOT
;
; PURPOSE:
;	Cette procedure fixe la couleur des traces 
;
; CATEGORY:
;	NRH gen
;
; CALLING SEQUENCE:
;	NRH_COLOR_PLOT, [Red], [Green], [Blue]
;
; INPUTS:
;
;	
; KEYWORD PARAMETERS:
;	NOLOAD	pas dechargement de la nouvelle table
;	RED	ancienne table de couleur (rouge)
;	GREEN	ancienne table de couleur (verte)
;	BLUE	ancienne table de couleur (bleue)
;	ROUT	table de couleur pour les routines (nrhr)
;
; OUTPUTS:
;	
;
; OPTIONAL OUTPUTS:
;	R, B, G  nouvelles tables de couleur
;	
; COMMON BLOCKS:
;	
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; PROCEDURE:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin(bonmartin@obspm.fr) le 10/10/00
;	le 08/11/01 entre table de couleur pour routine (JB)
;-*******************************************************************

PRO NRH_COLOR_PLOT, R, G, B, COLOR = Color, RED= Red, GREEN= Green, $
	BLUE= Blue , NOLOAD = Noload, ROUT = Rout

TVLCT, Red, Green, Blue, /GET
R= Red & G= Green & B= Blue

IF KEYWORD_SET(Rout) THEN BEGIN
	R[0:11]=[  0,000,128,  0,  0,  0,128,255,255,255,200,100]
	G[0:11]=[  0,  0,  0,  0,150,200,255,255,180,  0,  0,  0]
	B[0:11]=[  0,100,150,255,128,  0,  0,  0,  0,  0,  0,  0]
ENDIF ELSE BEGIN
	R[0:11]=[  0,255,255,  0,  0,255,255,255,  0,128,255,255]
	G[0:11]=[  0,255,  0,255,  0,128,255,  0,255,  0,  0,  0]
	B[0:11]=[  0,255,  0,  0,255,  0,  0,128,255,128,255,  0]
ENDELSE

IF NOT KEYWORD_SET (NOLOAD) THEN $
	TVLCT, R, G, B
END
