;+ ***********************************************************************
; NAME:
;	HEAD_SEFRAM
;
; PURPOSE:
;	Recuperation de certaines valeurs des KEYWORDS FITS des fichiers
;	SEFRAM.FTS
;
; CATEGORY:
;	Depannage en attendant la correction du programme d'acquistion
;
; CALLING SEQUENCE:
;	HEAD_SEFRAM
;
; INPUTS:
;	Non
;

; KEYWORD PARAMETERS:
;	DATE	en retour contient la date
;	DEB	en retour contient l'heure de debut
;	FIN	en retour contient l'heure de fin
;
;	REPERT	nom du repertoire contenant SEFRAM.fts si ce n'est pas le
;		repertoire courant
;	FILE	nom du fichier si ce n'est pas SEFRAM.FTS
;
; OUTPUTS:
;	Voir les KEYWORDS
;
; COMMON BLOCKS:
;	Non
;
; PROCEDURE:
;	Les valeurs sonrt recherchees dans les KEYWORDS
;		DATE_OBS
;		TIME_END
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par:JB le 07/02/01
;-*******************************************************************
PRO HEAD_SEFRAM, DATE= Date, DEB=Deb, FIN= Fin, REPERT= Repert, FILE=File

IF NOT KEYWORD_SET (FILE) THEN File='sefram.fts'
IF NOT KEYWORD_SET (REPERT) THEN Repert= ''

HEAD = HEADFITS(Repert+File)

FOR I=0, N_ELEMENTS(Head)-1 DO BEGIN
	IF STRMID(Head[i],0,8) EQ 'DATE_OBS' THEN BEGIN
		Date = STRMID(Head[i],11,8)
		DEB  = STRMID(Head[i],20,8)
	ENDIF
	IF STRMID(Head[i],0,8) EQ 'TIME_END' THEN $
		Fin= STRMID(Head[i],11,8)
ENDFOR

END
