
;+ ***********************************************************************
; NAME:
;	NRHR_LFREQ
;
; PURPOSE:
;	Cette fonction retourne un tableau de chaines contenant les
;	noms des frequences contenues dans le fichier
;
; CATEGORY:
;	NRH Routine
;
; CALLING SEQUENCE:
;	Liste = NRHR_LFREQ( Header)
;
; INPUTS:
;	HEADER	Header primaire du fichier
;	
; KEYWORD PARAMETERS:
;	
;
; OUTPUTS:
;	
;
; OPTIONAL OUTPUTS:
;	
; COMMON BLOCKS:
;	
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; PROCEDURE:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin(bonmarti@obspm.fr) le 10/10/00
;-*******************************************************************

FUNCTION NRHR_LFREQ, Header 

NFREQ = FXPAR( Header, 'NFREQ')
TAB_FREQ = STRARR (NFREQ)

FOR I = 0, Nfreq-1 DO BEGIN
     SFreq = 'FREQ'+STRCOMPRESS(String(I),/REMOVE_ALL)
     TAB_FREQ[i] = FXPAR (Header, Sfreq)
ENDFOR

RETURN, TAB_FREQ

END
